//
// (c)2016 Sassafras Software Inc.
//

(function () {

  // simple sanity check that there is a non-empty selection
  if (!app.selection || !app.selection.length)
    return;

  return({
    // version of the object for behavior consistency
    version: 1,
    // setup object describing what we want from the user
    setup: {
      fields: [
        {
          id: "tags",
          label: "Tags to be removed from selected items:",
          type: "tags",
          default: localStorage.getItem("tags"),
          required: true,
          lines: 3
        }
      ]
    },
    // proceed function to be called once input is complete
    proceed: function (params) {
      localStorage.setItem("tags", params.tags);

      // iterate through the objects in the selection
      app.selection.forEach({
        context: { list: params.tags },
        callback: function (obj) {
          var arr = [];
          if (obj.tags && obj.tags.length)
            removal(arr, expand(obj.tags), this.list);
          // set the property
          obj.tags = arr.join(";");
          // save the changes
          obj.commit();
        }
      });
    }
  });

  function expand (a) {
    return(a.split(";")
            .map(function (e) { return(e.trim()); })
            .filter(function (e) { return(e.length > 0); }));
  }

  function removal (a, b, c) {
	b.forEach(function (e) {
	  var esplit = e.split(":");
	  if (a.indexOf(e) < 0 && c.indexOf(e) < 0 && c.indexOf(esplit[0]) < 0)
		a.push(e);
	});
  }

})();
